-- =============================================
-- 名称：获取分页查询SQL中的Rowid范围
-- 作者：	邢港
-- 日期：2018/08/15
-- =============================================
CREATE PROCEDURE GetPageSqlRowid
  @tableName varchar(100),            --表名
  @pageIndex int=1,                   --第几页
  @pageSize int=10,                   --每页几条记录
  @strWhere nvarchar(1000)='1=1',     --条件
  @rowCount int output,               --记录总数
  @beginRowid int output,             --开始行号
  @endRowid int output                --结束行号
as

begin

declare
  @strTempSql nvarchar(3000),   --临时sql
  @pageCount int                --页数

--记录总数
set @strTempSql=N'select @rowCount=count(1) from '+@tableName+' where '+@strWhere
exec sp_executesql @strTempSql,N'@rowCount int output ',@rowCount output 

--处理分页大小
if @pageSize=0
  set @pageSize=@rowCount

--计算总页数
set @pageCount=(@rowCount+@pageSize-1)/@pageSize

--检查当前页数
if @pageIndex<1
begin
  set @pageIndex=1
end
else
begin
  if @pageIndex>@pageCount
  begin
    set @pageIndex=@pageCount
  end
end

--计算rowid范围
set @beginRowid=(@pageIndex-1)*@pageSize+1
set @endRowid=@pageIndex*@pageSize

end
go

