-- =============================================
-- 名称：获取问题列表
-- 作者：	邢港
-- 日期：2018/08/15
-- 说明：	
-- =============================================
CREATE PROCEDURE [dbo].[bw_Employee_GetPageList] 
  @pageIndex int=1,                   --第几页
  @pageSize int=15,                   --每页几条记录
  @keywords varchar(100)=''
AS
begin

declare
  @rowCount int,                      --记录总数
  @beginRowid int,                    --开始行号
  @endRowid int                       --结束行号

--关键字为空时替换成%，否则前后添加%
set @keywords=iif(isnull(@keywords,'')='','%','%'+@keywords+'%')

--将问题单据中新用户名生成记录插入Employee表
insert into bw_Employee (EmployeeGuid, EmployeeName, DepartGuid, DepartName)
select distinct a.EditUserGuid,a.EditUserName,'默认','默认' 
from bw_IssueRecord a where not exists(select * from bw_Employee b where a.EditUserGuid=b.EmployeeGuid)

--获取总行数
select @rowCount=count(*) from bw_Employee where EmployeeName like @keywords or DepartName like @keywords

--获取分页的起始和终止rowid
exec GetPageRowid @pageIndex=@pageIndex,@pageSize=@pageSize,@rowCount=@rowCount,@beginRowid=@beginRowid out,@endRowid=@endRowid out

--获取结果
;with t as
(select ROW_NUMBER() OVER(ORDER BY EmployeeName) as rowid,* 
  from bw_Employee 
  where EmployeeName like @keywords or DepartName like @keywords)
select
  t.EmployeeGuid,t.EmployeeName,DepartName
from t where t.rowid between @beginRowid and @endRowid

--获取记录总数
select @rowCount as [RowCount] 

end
go

grant execute on bw_Employee_GetPageList to xjapp
go

