-- =============================================
-- 名    称：获取位置信息存储过程
-- 作    者：何宏达
-- 日    期：2018年07月18日
-- 功能简介：获取位置信息
-- =============================================
CREATE PROCEDURE [dbo].[bw_GetLocationList]
  @name varchar(50)='%'
AS
begin
set @name=iif(isnull(@name,'')='','%','%'+@name+'%')
select 
  Guid,
  Name,
  isnull(b.DepartName,'') DepartName,
  convert(varchar(100),UpdateTime,114) UpdateTime,
  Longitude,
  Latitude,
  (select count(BillNO) from dbo.bw_FireWorking where State='进行中' and MonitorUser=Name ) as FireWorking 
from bw_sswzdjb a left join bw_Employee b on a.Guid = b.EmployeeGuid
where UpdateTime>dateadd(minute,-30,getdate()) and Name like @name 
order by UpdateTime desc
END
go

grant execute on bw_GetLocationList to xjapp
go

