-- =============================================
-- 名称：获取问题列表
-- 作者：	邢港
-- 日期：2018/08/15
-- 说明：	
-- =============================================
CREATE PROCEDURE [dbo].[bw_IssueRecord_GetPageList] 
  @beginDate date,
  @endDate date,
  @pageIndex int=1,                   --第几页
  @pageSize int=10,                   --每页几条记录
  @keywords varchar(100)='',
  @isHandle varchar(10)='',
  @userGuid varchar(50)='%',
  @editUserName varchar(50)=''
AS
begin

declare
  @rowCount int,                      --记录总数
  @beginRowid int,                    --开始行号
  @endRowid int,                      --结束行号
  @deptName varchar(50)

--关键字为空时替换成%，否则前后添加%
set @keywords=iif(isnull(@keywords,'')='','%','%'+@keywords+'%')
set @editUserName=iif(isnull(@editUserName,'')='','%','%'+@editUserName+'%')

--用户内码不为空则查询用户所在小组的单据，否则查询所有小组
if @userGuid='%'
  set @deptName='%'
else
  select @deptName=isnull(DepartName,'%') from bw_Employee where EmployeeGuid=@userGuid
if @deptName is null set @deptName='xxx' --找不到用户则不显示任何单据

--获取总行数
select @rowCount=count(*) 
from bw_IssueRecord a left join bw_Employee b on a.EditUserGuid=b.EmployeeGuid
where BillDate between @beginDate and @endDate 
  and (Title like @keywords or Locale like @keywords or Content like @keywords or EditUserName like @keywords)
  and IsHandle=iif(isnull(@isHandle,'')='',IsHandle,@isHandle)
  and b.DepartName like @deptName
  and a.EditUserName like @editUserName

--获取分页的起始和终止rowid
exec GetPageRowid @pageIndex=@pageIndex,@pageSize=@pageSize,@rowCount=@rowCount,@beginRowid=@beginRowid out,@endRowid=@endRowid out

--获取结果
;with t as
(select ROW_NUMBER() OVER(ORDER BY BillNO desc) as rowid,a.*,b.DepartName 
  from bw_IssueRecord a left join bw_Employee b on a.EditUserGuid=b.EmployeeGuid 
  where BillDate between @beginDate and @endDate 
  and (Title like @keywords or Locale like @keywords or Content like @keywords or EditUserName like @keywords)
  and IsHandle=iif(isnull(@isHandle,'')='',IsHandle,@isHandle)
  and b.DepartName like @deptName
  and a.EditUserName like @editUserName)
select
  convert(varchar(10),BillDate,23) as BillDate,
  BillNO,
  Type,
  Locale,
  Title,
  Mhqbm,
  Content,
  EditUserName,
  DepartName,
  convert(varchar(50),EditTime,20) EditTime,
  IsHandle,
  HandleNote,
  HandleUserName,
  convert(varchar(50),HandleTime,20) HandleTime
from t where t.rowid between @beginRowid and @endRowid

--获取记录总数
select @rowCount as [RowCount] 

end
go

grant execute on bw_IssueRecord_GetPageList to xjapp
go

