-- =============================================
-- 名称：获取工作汇报列表
-- 作者：	邢港
-- 日期：2019/03/13
-- 说明：	
-- =============================================
CREATE PROCEDURE [dbo].[bw_work_report_GetPageList] 
  @beginDate date,
  @endDate date,
  @pageIndex int=1,                   --第几页
  @pageSize int=10                    --每页几条记录
AS
begin

declare
  @rowCount int,                      --记录总数
  @beginRowid int,                    --开始行号
  @endRowid int                       --结束行号

--获取总行数
select @rowCount=count(*) 
from bw_work_report a
where WorkDate between @beginDate and @endDate 

--获取分页的起始和终止rowid
exec GetPageRowid @pageIndex=@pageIndex,@pageSize=@pageSize,@rowCount=@rowCount,@beginRowid=@beginRowid out,@endRowid=@endRowid out

--获取结果
;with t as
(select ROW_NUMBER() OVER(ORDER BY WorkDate desc) as rowid,a.* 
  from bw_work_report a
  where WorkDate between @beginDate and @endDate)
select
  convert(varchar(10),WorkDate,23) as WorkDate,
  Guid,
  UpdateTime,
  Name,
  EntryPass,
  PatrolNumber,
  VisRegistration,
  CarRegistration,
  VioOfDiscipline,
  ReceiveExpress,
  SendExpress,
  ReOfTemGoods,
  SeOfTemGoods,
  Remarks
from t where t.rowid between @beginRowid and @endRowid

--获取记录总数
select @rowCount as [RowCount] 

end
go

grant execute on bw_work_report_GetPageList to xjapp
go

